/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package b2jlibs.graphics;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

/**
 *
 * @author David Krywult
 */
public class Input implements KeyListener, MouseListener {
    final int keyct=222;
    final private int[] keyMatchings = new int[keyct];
    private boolean[] isHit = new boolean[keyct];
    private boolean[] isReleased = new boolean[keyct];
    private boolean[] isDown = new boolean[keyct];
    
    public Input() {
        keyMatchings[27] = 1;  //ESC
        keyMatchings[37] = 203;//LEFT CURSOR
        keyMatchings[38] = 200;//UP CURSOR
        keyMatchings[39] = 205;//RIGHT CURSOR
        keyMatchings[40] = 208;//DOWN CURSOR
    }
    
    public boolean getKeyHit(int nr) {
        boolean hit = isHit[nr];
        isHit[nr] = false;
        return hit;
    }
    public boolean getKeyDown(int nr) {
        return isDown[nr];
    }
    
    @Override
    public void keyTyped(KeyEvent ke) {}

    @Override
    public void keyPressed(KeyEvent ke) {
        if (ke.getKeyCode()>=0&&ke.getKeyCode()<keyct && !isDown[keyMatchings[ke.getKeyCode()]]) {
            isHit[keyMatchings[ke.getKeyCode()]]=true;
            isDown[keyMatchings[ke.getKeyCode()]]=true;
        }
    }

    @Override
    public void keyReleased(KeyEvent ke) {
        if (ke.getKeyCode()>=0&&ke.getKeyCode()<keyct) {
            isDown[keyMatchings[ke.getKeyCode()]]=false;
        }
    }

    @Override
    public void mouseClicked(MouseEvent me) {
    }

    @Override
    public void mousePressed(MouseEvent me) {
    }

    @Override
    public void mouseReleased(MouseEvent me) {}

    @Override
    public void mouseEntered(MouseEvent me) {}

    @Override
    public void mouseExited(MouseEvent me) {}
    
}
